// Adapted from the code by
//  Rui Santos
//  https://randomnerdtutorials.com
// Modified by - Pavan M. Kuchar on 26th April 2021  
#include <LiquidCrystal_I2C.h>
#include <Wire.h>
// if you don't know your display address, run an I2C scanner sketch
LiquidCrystal_I2C lcd(0x3F, 16, 2);  
String messageStatic = "Hello World"; //Static Message
String messageToScroll = "I m Pavan Kuchar  at FAB21"; //This is a scrolling message with more than 16 characters
// Function to scroll text
// The function acepts the following arguments:
// row: row number where the text will be displayed
// message: message to scroll
// delayTime: delay between each character shifting
// lcdColumns: number of columns of your LCD
void scrollText(int row, String message, int delayTime, int lcdColumns) {
  for (int i=0; i < lcdColumns; i++) {
    message = " " + message;  
  } 
  message = message + " "; 
  for (int pos = 0; pos < message.length(); pos++) {
    lcd.setCursor(0, row);
    lcd.print(message.substring(pos, pos + lcdColumns));
    delay(delayTime);
  }
}
void setup(){
  Serial.begin (115200);  
  Wire.begin (33, 32);
  // initialize LCD
  lcd.begin();
  // turn on LCD backlight                      
  lcd.backlight();
}
void loop(){
  // set cursor to first column, first row
  lcd.setCursor(0, 0);
  // print static message
  lcd.print(messageStatic);
  // print scrolling message
  scrollText(1, messageToScroll, 250, 16);
}
